#!/bin/sh

# BIG BROTHER MONITORING SCRIPT
#
#
# SEND THE TEST RESULTS TO THE DISPLAY SERVER USING bb

# echo "***** BBHOME IS SET TO $BBHOME IN bb-net"

. $BBHOME/etc/bbdef.sh		# INCLUDE STANDARD DEFINITIONS

$GREP "^[1-9]" $BBHOSTS |
while read line
do
	set $line
	IPADDR=`echo $1 | sed "s/\.//g"`
	FULLNAME=$2
	set `echo $FULLNAME | sed "s/\./ /"`
	MACHINE=$1
	#
	#================================================
	# CONNECTIVITY TEST
	# MUST LOOK AT THIS, THE TELNET TEST WAS MUCH
	# BETTER, BUT DIDN'T WORK ON FREEBSD (What's New?)
	# Added support for non-standard pings. gunnar@bitcon.no
	#================================================
	#
	$PING $PINGPAR1 $FULLNAME $PINGPAR2 > $BBTMP/BBPING 2>&1
	$GREP "bytes from" $BBTMP/BBPING > /dev/null 2>&1
	if test $? != "0"
	then
		COLOR="red"
		LINE="Can't connect..."
		if test "$TELNETPAGE" = "Y"
		then
			LINE="$LINE (paging)"
			$BB $BBPAGE "page $PAGER ${TELNETERR}${IPADDR}"
		fi
	else
		COLOR="green"
		LINE="Connection OK"
	fi
	$BB $BBDISP "status ${MACHINE}.conn $COLOR `date` $LINE" 
	$RM -f $BBTMP/BBPING		# GET RID OF THE LEFTOVERS

	#
	#================================================
	# HTTP TEST, IF REQUIRED
	# WE'RE LOOKING FOR A http://location LINE
	#================================================
	#
	echo "$line" | $GREP http > /dev/null 2>&1
	if test $? = "0"
	then
		set $line
		#
		# FIND THE http LINE
		# SHIFT UNTIL WE GET THERE
		#
		while test "$HTTP" = ""
		do
			shift;
			HTTP=`echo $1 | $GREP http`
		done
	
		$LYNX $HTTP > $BBTMP/HTTP 2>&1

		if test "$?" != 0
		then
			LINE="Lost HTTP connection."
			if test "$PAGER" != ""
			then
				LINE="$LINE - Paging..."
				$BB $BBPAGE "page ${PAGER} ${HTTPERR}${IPADDR}"
			fi
			$BB $BBDISP "status ${MACHINE}.http red `date` $LINE"
		else
		#
		# THERE COULD BE A SERVER ERROR HIDING HERE... CHECK FOR IT
		#
			$GREP "Error" $BBTMP/HTTP > /dev/null  2>&1
			if test "$?" = "0"
			then
				LINE="Server up, but web page error..."
				COLOR="yellow"
				$BB $BBDISP "status ${MACHINE}.http $COLOR `date` $LINE" 
			else
				LINE="Server is OK"
				COLOR="green"
				$BB $BBDISP "status ${MACHINE}.http $COLOR `date` $LINE" 
			fi
		fi
		$RM -f $BBTMP/HTTP
		HTTP=""
	fi
done
